#ifndef __MISC_H__
#define __MISC_H__

#define null                                ((void *)0x000000)
#define false                               0
#define true                                1

#define MFP_BASE_ADR                        0xE88000

#define GPIP_ALARM							(1 << 0)
#define GPIP_EXPON							(1 << 1)
#define GPIP_POWSW							(1 << 2)
#define GPIP_OPMIRQ							(1 << 3)
#define GPIP_VDISP							(1 << 4)
#define GPIP_CRTC							(1 << 6)
#define GPIP_HSYNC							(1 << 7)

#define mfp                                 ((*(volatile struct MFP *)MFP_BASE_ADR))

typedef unsigned char byte;
typedef unsigned short bool;

/* MFP address */
struct MFP
 {
  unsigned short gpdr;
  unsigned short aer;
  unsigned short ddr;
  unsigned short iera;
  unsigned short ierb;
  unsigned short ipra;
  unsigned short iprb;
  unsigned short isra;
  unsigned short isrb;
  unsigned short imra;
  unsigned short imrb;
  unsigned short vr;
  unsigned short tacr;
  unsigned short tbcr;
  unsigned short tcdcr;
  unsigned short tadr;
  unsigned short tbdr;
  unsigned short tcdr;
  unsigned short tddr;
  unsigned short scr;
  unsigned short ucr;
  unsigned short rsr;
  unsigned short tsr;
  unsigned short udr;
} __attribute__ ((packed));

static void inline wait_for_vblank (void)
{
  /* CRTC under vdisp */
  while (mfp.gpdr & GPIP_VDISP);
}

static void inline wait_for_vdisp (void)
{
  /* CRTC under vblank */
  while (!(mfp.gpdr & GPIP_VDISP));
}

#endif

